#!/usr/bin/perl

use Linux::Inotify2;
use WWW::Mechanize::Firefox;
my $mech = WWW::Mechanize::Firefox->new();

my $inotify = new Linux::Inotify2
  or die "unable to create new inotify object: $!";

@org_files =  glob("./org/*.org");

$" = "\n";
print "@org_files\n";

$ignore_next = 0;


foreach(@org_files){
# add watchers
$inotify->watch ($_, IN_MODIFY, sub 
{
    print ("IGNORE : $ignore_next\n");
    # ok, for some reason this get's called exactly 
    # twice every time the file is saved from emacs.
    # so ignore every other invocation.
    if ($ignore_next) {
	$ignore_next = 0;
	return;
    }
    $ignore_next = 1;

    my $e = shift;
    my $name = $e->fullname;
    print "$name was modified\n" if $e->IN_MODIFY;
    $output = `weave $name`;
    $path = `readlink -f $name`;
    $path =~ s|/home/r/proj|http://aurellem.localhost|;
    $path =~ s|org|html|g;
    $mech->get($path);
});
}


# manual event loop
1 while $inotify->poll;
